clear;
rng(12345,'twister');

randn('seed',987);
rand('seed',123);

delete(gcp('nocreate'));
myCluster = parcluster('local');
myCluster.NumWorkers = 3; 
saveProfile(myCluster);    
parpool(3);

% to interpret
%[rej_gauss rej_bs rej_bspiv rej_sym_bs rej_nosel rej_noselpiv rej_sym_nosel rej_uniform rej_pgbspiv rej_subs];
%[one_side_gauss_l one_side_bspiv_l one_side_noselpiv_l one_side_uniform_l one_side_pgbspiv_l one_side_subs_l one_side_gauss_u one_side_bspiv_u one_side_noselpiv_u one_side_uniform_u one_side_pgbspiv_u one_side_subs_u];

                  


B_max = 10000;
S_max = 2000;

design = 4;
unbalanced = 0;

rvec = [1 2 3];
if unbalanced==1
    rvec = [1 3]
end


j = 1;
k = 1;

tic

for r = rvec
    
    for size = [10 20 50 100] 
    
        
        N = size;
        T = size;
        
        if unbalanced==1
            T = 20;
        end

        
        
        sg_a = 0.5;
        sg_g = 0.5;
        sg_e = 0.5;
        mu_a = 1;
        mu_g = 1;

        oracle = 0;

        
        if r==1 
            
            if design==4
                sg_a = 0.2;
                sg_g = 0.2;
                sg_e = 0; 
                mu_a = 1;
                mu_g = 0;
                rbar = 3;
            end
            
            if design==2
                sg_a = 0.5;
                sg_g = 0.1;
                sg_e = 0.2;
                mu_a = 0;
                mu_g = 0;
                rbar = 1;
            end
            
          
        end
    
        if r==2
            
            if design==4
                sg_a = 0.2;
                sg_g = 0.2;
                sg_e = 0;
                mu_a = 1/sqrt(T);
                mu_g = 0/sqrt(N);
                rbar = 3;
            end
            
            if design==2
                sg_a = 5/T;
                sg_g = 1/T;
                sg_e = 0.2;
                mu_a = 0;
                mu_g = 0;
                rbar = 1;
            end
            
        end
    
        
        if r==3
            
            if design==4
                sg_a = 0.2;
                sg_g = 0.2;
                sg_e = 0;
                mu_a = 0;
                mu_g = 0;
                rbar = 3;
            end
            
            if design==2
                sg_a = 0;
                sg_g = 0;
                sg_e = 0.2;
                mu_a = 0;
                mu_g = 0;
                rbar = 1;
            end
            
            oracle = 0;
        end
        
        

        
        
           

        [std_err1,rej_rate1,os_rej1,pct_all1,pct_err_all1,mse_all1,rej_gauss_gph,rej_subs_gph,rej_bs_gph,rej_bspiv_gph] = simulate_1pct(N,T,B_max,S_max,design,oracle,mu_a,mu_g,sg_a,sg_g,sg_e);

 
        std_err(j,:) = std_err1;
        rej_rate(j,:) = rej_rate1;
        os_rej(j,:) = os_rej1;
        siz_vec(j,:) = [N T];
        
        
        idx = 5*(j-1);
        pct_all(idx+1:idx+5,:) = pct_all1;
        
        idx = 4*(j-1);
        pct_err_all(idx+1:idx+4,:) = pct_err_all1;
        mse_all(idx+1:idx+4,:) = mse_all1;
        
        

        if r==rbar
            
            nom_prob = (1:50)/50-0.01;
            
            cdf_gauss = mean(rej_gauss_gph);
            erp_gauss(k,:) = smooth(cdf_gauss - nom_prob,0.2);      
            cdf_subs = mean(rej_subs_gph);
            erp_subs(k,:) = smooth(cdf_subs - nom_prob,0.2);
              
            
            cdf_bs = mean(rej_bs_gph);
            erp_bs(k,:) = smooth(cdf_bs - nom_prob,0.2);
            cdf_bspiv = mean(rej_bspiv_gph);
            erp_bspiv(k,:) = smooth(cdf_bspiv - nom_prob,0.2);


            k = k+1;
        
        end
            

        
               
        j = j+1;
        
    end

end


std_err
os_rej
rej_rate

design
unbalanced


fid = fopen('tab_nonsep_1pct_rej.txt','w');
res_mat = [siz_vec rej_rate];
formatSpec = '%.0f &%.0f && %.3f & %.3f & %.3f & %.3f & %.3f& %.3f& %.3f & %.3f & %.3f & %.3f & %.3f \\\\ \n';
fprintf(fid,formatSpec,res_mat');
fclose('all');

fid = fopen('tab_nonsep_1pct_os.txt','w');
res_mat = [siz_vec os_rej];
formatSpec = '%.0f&%.0f && %.3f & %.3f & %.3f & %.3f & %.3f & %.3f && %.3f& %.3f& %.3f & %.3f & %.3f &%.3f \\\\ \n';
fprintf(fid,formatSpec,res_mat');
fclose('all');

delete(gcp('nocreate'));