
clear;
rng(12345,'twister');

randn('seed',987);
rand('seed',123);

delete(gcp('nocreate'));
myCluster = parcluster('local');
myCluster.NumWorkers = 3; 
saveProfile(myCluster);    
parpool(3);

% to interpret
%[rej_gauss rej_bs rej_bspiv rej_sym_bs rej_nosel rej_noselpiv rej_sym_nosel rej_uniform rej_pgbspiv rej_subs];
%[one_side_gauss_l one_side_bspiv_l one_side_noselpiv_l one_side_uniform_l one_side_pgbspiv_l one_side_subs_l one_side_gauss_u one_side_bspiv_u one_side_noselpiv_u one_side_uniform_u one_side_pgbspiv_u one_side_subs_u];

                  


B_max = 10000;
S_max = 2000;


design = 4;
unbalanced = 0;

oracle = 0;

rvec = [1 2 3];
if unbalanced==1
    dvec = [1 2 3]
end



j = 1;
k = 1;

tic

for r = rvec    
    
    for size = [10 20 50 100 200]
    
        
        N = size;
        T = size;
        
        if unbalanced==1
            T = 20;
        end

        
        
        sg_a = 0.5;
        sg_g = 0.5;
        sg_e = 0.5;
        mu_a = 1;
        mu_g = 1;
        
        beta = [1;1];

        

        
        if r==1 
            
            if design==4
                sg_a = 0.2;
                sg_g = 0.2;
                sg_e = 0; 
                mu_a = 5;
                mu_g = 0;
                rbar = 3;
            end
            
            if design==2
                sg_a = 0.5;
                sg_g = 0.1;
                
                sg_e = 0.2;
                mu_a = 0;
                mu_g = 0;
                rbar = 1;
            end
            
          
        end
    
        if r==2
            
            if design==4
                sg_a = 0.2;
                sg_g = 0.2;
                sg_e = 0;
                mu_a = 5/sqrt(T);
                mu_g = 0/sqrt(N);
                rbar = 3;
            end
            
            if design==2
                sg_a = 1/T;
                sg_g = 0.2/N;
                sg_a = 0.5/T;
                sg_g = 0.1/N;
                sg_e = 0.2;
                mu_a = 0;
                mu_g = 0;
                rbar = 1;
            end
            
        end
    
        
        if r==3
            
            if design==4
                sg_a = 0.2;
                sg_g = 0.2;
                sg_e = 0;
                mu_a = 0;
                mu_g = 0;
                rbar = 3;
            end
            
            if design==2
                sg_a = 0;
                sg_g = 0;
                sg_e = 0.2;
                mu_a = 0;
                mu_g = 0;
                rbar = 1;
            end
            
           % oracle = 0;
        end
        
        
        
        
           

        [rej_rate1,alt1_rate1,alt2_rate1,rej_gauss_gph,rej_subs_gph,rej_bs_gph,rej_bspiv_gph] = simulate_reg(N,T,B_max,S_max,design,oracle,beta,mu_a,mu_g,sg_a,sg_g,sg_e);



        rej_rate(j,:) = 100*rej_rate1;
        alt1_rate(j,:) = 100*alt1_rate1;
        alt2_rate(j,:) = 100*alt2_rate1;
        siz_vec(j,:) = [N T];



        if r==rbar
            
            nom_prob = (1:50)/50-0.01;
            
            cdf_gauss = mean(rej_gauss_gph);
            erp_gauss(k,:) = smooth(cdf_gauss - nom_prob,0.2);      
            cdf_subs = mean(rej_subs_gph);
            erp_subs(k,:) = smooth(cdf_subs - nom_prob,0.2);
              
            
            cdf_bs = mean(rej_bs_gph);
            erp_bs(k,:) = smooth(cdf_bs - nom_prob,0.2);
            cdf_bspiv = mean(rej_bspiv_gph);
            erp_bspiv(k,:) = smooth(cdf_bspiv - nom_prob,0.2);

            
            
            k = k+1;
        
        end


        
               
        j = j+1;
        
    end

end



rej_rate
alt1_rate
alt2_rate

toc

stop


figure
hold on
plot(nom_prob',abs(erp_gauss(1,:))','LineWidth',1,'LineStyle','-.','Color','r');
plot(nom_prob',abs(erp_subs(1,:))','LineWidth',1,'LineStyle','-.','Color','m');
plot(nom_prob',abs(erp_bs(1,:))','LineWidth',1,'LineStyle','--','Color','c');
plot(nom_prob',abs(erp_bspiv(1,:))','LineWidth',1,'LineStyle','-','Color','b');
legend('Gaussian','Subsampling','Bootstrap','Pivotal Bootstrap');
plot(nom_prob',zeros(50,1),'LineWidth',0.8,'LineStyle',':','Color','k');axis([0 1 0 0.05]);
axis([0 1 0 0.12]);
title('N = 10, T = 10');
hold off


figure
hold on
plot(nom_prob',abs(erp_gauss(2,:))','LineWidth',1,'LineStyle','-.','Color','r');
plot(nom_prob',abs(erp_subs(2,:))','LineWidth',1,'LineStyle','-.','Color','m');
plot(nom_prob',abs(erp_bs(2,:))','LineWidth',1,'LineStyle','--','Color','c');
plot(nom_prob',abs(erp_bspiv(2,:))','LineWidth',1,'LineStyle','-','Color','b');
legend('Gaussian','Subsampling','Bootstrap','Pivotal Bootstrap');
plot(nom_prob',zeros(50,1),'LineWidth',0.8,'LineStyle',':','Color','k');
plot(nom_prob',zeros(50,1),'LineWidth',0.8,'LineStyle',':','Color','k');axis([0 1 0 0.05]);
axis([0 1 0 0.12]);
title('N = 20, T = 20');
hold off

figure
hold on
plot(nom_prob',abs(erp_gauss(3,:))','LineWidth',1,'LineStyle','-.','Color','r');
plot(nom_prob',abs(erp_subs(3,:))','LineWidth',1,'LineStyle','-.','Color','m');
plot(nom_prob',abs(erp_bs(3,:))','LineWidth',1,'LineStyle','--','Color','c');
plot(nom_prob',abs(erp_bspiv(3,:))','LineWidth',1,'LineStyle','-','Color','b');
legend('Gaussian','Subsampling','Bootstrap','Pivotal Bootstrap');
plot(nom_prob',zeros(50,1),'LineWidth',0.8,'LineStyle',':','Color','k');
plot(nom_prob',zeros(50,1),'LineWidth',0.8,'LineStyle',':','Color','k');
axis([0 1 0 0.12]);
title('N = 50, T = 50');
hold off

figure
hold on
plot(nom_prob',abs(erp_gauss(4,:))','LineWidth',1,'LineStyle','-.','Color','r');
plot(nom_prob',abs(erp_subs(4,:))','LineWidth',1,'LineStyle','-.','Color','m');
plot(nom_prob',abs(erp_bs(4,:))','LineWidth',1,'LineStyle','--','Color','c');
plot(nom_prob',abs(erp_bspiv(4,:))','LineWidth',1,'LineStyle','-','Color','b');
legend('Gaussian','Subsampling','Bootstrap','Pivotal Bootstrap');
plot(nom_prob',zeros(50,1),'LineWidth',0.8,'LineStyle',':','Color','k');
plot(nom_prob',zeros(50,1),'LineWidth',0.8,'LineStyle',':','Color','k');
axis([0 1 0 0.12]);
title('N = 100, T = 100');
hold off

toc

stop

fid = fopen('tab_reg_5pct_rej_did.txt','w');
res_mat = [siz_vec rej_rate];
formatSpec = '%.0f &%.0f && %.3f && %.3f & %.3f & %.3f && %.3f& %.3f& %.3f \\\\ \n';
fprintf(fid,formatSpec,res_mat');
fclose('all');

fid = fopen('tab_reg_5pct_alt1_did.txt','w');
res_mat = [siz_vec alt1_rate];
formatSpec = '%.0f &%.0f && %.3f && %.3f & %.3f & %.3f && %.3f& %.3f& %.3f \\\\ \n';
fprintf(fid,formatSpec,res_mat');
fclose('all');

fid = fopen('tab_reg_5pct_alt2_did.txt','w');
res_mat = [siz_vec alt2_rate];
formatSpec = '%.0f &%.0f && %.3f && %.3f & %.3f & %.3f && %.3f& %.3f& %.3f \\\\ \n';
fprintf(fid,formatSpec,res_mat');
fclose('all');


delete(gcp('nocreate'));
