function [y_LS_bs,t_LS_bs,y_DD_bs,t_DD_bs] = pigeonhole_reg(y,X,beta_LS,beta_DD,swtch1,swtch2,S_max,dyadic)
        
    [N,T] = size(y);
    y_LS_bs = zeros(S_max,1);
    t_LS_bs = zeros(S_max,1);
    y_DD_bs = zeros(S_max,1);
    t_DD_bs = zeros(S_max,1);
    
    for s = 1:S_max
        
        row_sel = ceil(N*rand(N,1));
        col_sel = ceil(T*rand(1,T));
        
        y_rw_sel = y(row_sel,:);
        y_star = y_rw_sel(:,col_sel);
        X_rw_sel = X(row_sel,:);
        X_star = X_rw_sel(:,col_sel);
        
        
        if dyadic==1
            y_rw_sel = y(row_sel,:);
            y_star = y_rw_sel(:,row_sel');
            X_rw_sel = X(row_sel,:);
            X_star = X_rw_sel(:,row_sel');
        end
        
        X_dd_star = X_star - repmat(mean(X_star,2),1,T) - repmat(mean(X_star,1),N,1) + mean(mean(X_star));
        y_dd_star = y_star - repmat(mean(y_star,2),1,T) - repmat(mean(y_star,1),N,1) + mean(mean(y_star));
        
        [beta_LS_star,beta_DD_star,se_LS_star,se_LS_nosel_star,se_DD_star] = reg_coeffs(y_star,X_star,y_dd_star,X_dd_star,swtch1,swtch2);
        
        
        y_LS_bs(s,1) = (beta_LS_star(2,1)-beta_LS(2,1));
        t_LS_bs(s,1) = (beta_LS_star(2,1)-beta_LS(2,1))/se_LS_nosel_star(2,1);
        y_DD_bs(s,1) = (beta_DD_star(1,1)-beta_DD(1,1));
        t_DD_bs(s,1) = (beta_DD_star(1,1)-beta_DD(1,1))/se_DD_star(1,1);
        
    end
    
    y_LS_bs = sort(y_LS_bs);
    t_LS_bs = sort(t_LS_bs);
    y_DD_bs = sort(y_DD_bs);
    t_DD_bs = sort(t_DD_bs);
    
end