function [beta_LS,beta_DD,se_LS,se_LS_nosel,se_DD] = reg_coeffs(y,X,y_dd,X_dd,swtch1,swtch2)

[NN,TT] = size(X);
X_mat = [ones(NN*TT,1) reshape(X,NN*TT,1)];
y_mat = reshape(y,NN*TT,1);
X_dd_mat = reshape(X_dd,NN*TT,1);
y_dd_mat = reshape(y_dd,NN*TT,1);
beta_LS = inv(X_mat'*X_mat)*X_mat'*y_mat;
beta_DD = inv(X_dd_mat'*X_dd_mat)*X_dd_mat'*y_dd_mat;
u_hat = y - beta_LS(1,1) - X*beta_LS(2,1);
w_hat = y_dd - X_dd*beta_DD;


a_proj = [sum(u_hat-mean(mean(u_hat)),2),sum(X.*u_hat-mean(mean(X.*u_hat)),2)];
g_proj = [sum(u_hat-mean(mean(u_hat)),1);sum(X.*u_hat-mean(mean(X.*u_hat)),1)]';
w_proj1 = reshape(u_hat-repmat(mean(u_hat,2),1,TT)-repmat(mean(u_hat,1),NN,1)+mean(mean(u_hat)),NN*TT,1);
w_proj2 = reshape(X.*u_hat-repmat(mean(X.*u_hat,2),1,TT)-repmat(mean(X.*u_hat,1),NN,1)+mean(mean(X.*u_hat)),NN*TT,1);
w_proj = [w_proj1 w_proj2];
Omega_a = a_proj'*a_proj;
Omega_g = g_proj'*g_proj;
Omega_w = w_proj'*w_proj;
Omega_LS = swtch1*max(Omega_a-0*Omega_w,0) + swtch2*max(Omega_g-0*Omega_w,0) + Omega_w;
Omega_LS_nosel = Omega_a + Omega_g - Omega_w;
Sigma_LS = inv(X_mat'*X_mat)*Omega_LS*inv(X_mat'*X_mat);
se_LS = real(sqrt(diag(Sigma_LS)));
Sigma_LS_nosel = inv(X_mat'*X_mat)*Omega_LS_nosel*inv(X_mat'*X_mat);
se_LS_nosel = sqrt(diag(Sigma_LS_nosel));
w_proj_DD = reshape(X_dd.*w_hat,NN*TT,1);
Omega_DD = cov(w_proj_DD);
Sigma_DD = inv(X_dd_mat'*X_dd_mat/NN/TT)*Omega_DD*inv(X_dd_mat'*X_dd_mat/NN/TT)/NN/TT;
se_DD = real(sqrt(diag(Sigma_DD)));

end