function [rej_rate,alt1_rate,alt2_rate,rej_gauss_gph,rej_subs_gph,rej_bs_gph,rej_bspiv_gph] = simulate_reg(N,T,B_max,S_max,design,oracle,beta,mu_a,mu_g,sg_a,sg_g,sg_e)

y_LS_rep = zeros(B_max,1);
t_LS_rep = zeros(B_max,1);
y_DD_rep = zeros(B_max,1);
t_DD_rep = zeros(B_max,1);

rej_all = zeros(B_max,7);
alt1_all = zeros(B_max,7);
alt2_all = zeros(B_max,7);

pct_gauss_rep = zeros(B_max,9); 

rej_gauss_gph = zeros(B_max,50);
rej_subs_gph = zeros(B_max,50);
rej_bs_gph = zeros(B_max,50);
rej_bspiv_gph = zeros(B_max,50);


if design==1
    X = randn(N,T)+0.2*repmat(randn(N,1),1,T) + 0.2*repmat(randn(1,T),N,1);
end

if design==2
    X = randn(N,T)+0.2*repmat(randn(N,1),1,T) + 0.2*repmat(randn(1,T),N,1);
    ch_date = 1+ ceil(T*rand(N,1));
    date = (1:T);
    X = repmat(date,N,1)>=repmat(ch_date,1,T);
end

if design==3
    X = randn(N,T)+0.2*repmat(randn(N,1),1,T) + 0.2*repmat(randn(1,T),N,1);
end

if design==4
    ch_date = 1+ ceil(T*rand(N,1));
    date = (1:T);
    X = repmat(date,N,1)>=repmat(ch_date,1,T);

end


if design==5
    X = randn(N,T);
end


if design==6

    X = (1-2*repmat(randn(N,1)>0,1,T)).*(1-2*repmat(randn(1,T)>0,N,1));
    
end

parfor b = 1:B_max
         
            if design==1
                
                alpha = randn(N,1);
                gamma = randn(1,T);
                epsilon = randn(N,T);
                
                u = sqrt(sg_a)*repmat(alpha,1,T) + sqrt(sg_g)*repmat(gamma,N,1) + sqrt(sg_e)*epsilon;
                y = beta(1,1) + X*beta(2,1) + u;
                dyadic = 0;
              
            end
            
            if design==2
                
                lgn_scale = 0.5;
                lgn_var = (exp(lgn_scale^2)-1)*exp(lgn_scale^2);
                alpha = 0*randn(N,1) + 1*(exp(lgn_scale*randn(N,1))- exp(lgn_scale^2/2))/sqrt(lgn_var);          
                gamma = randn(1,T);
                epsilon = randn(N,T);
                              
                u = sqrt(sg_a)*repmat(alpha,1,T) + sqrt(sg_g)*repmat(gamma,N,1) + sqrt(sg_e)*epsilon;
                y = beta(1,1) + X*beta(2,1) + u;
                dyadic = 0;
          
            end
            
            if design==3
                
                U = rand(N,1)>0.9;
                alpha = (0.5 + 1.5*U).*randn(N,1);
                U = rand(1,T)>0.9;
                gamma = (0.5 + 1.5*U).*randn(1,T);
                epsilon = randn(N,T);
                
                u = sqrt(sg_a)*repmat(alpha,1,T) + sqrt(sg_g)*repmat(gamma,N,1) + sqrt(sg_e)*epsilon;
                y = beta(1,1) + X*beta(2,1) + u;
               
            
                dyadic = 0;
               
            
            end        
            
            if design==4
                
                alpha = randn(N,1);
                gamma = randn(1,T);
                epsilon = randn(N,T);
                
                u = sqrt(sg_a*sg_g)*((repmat(alpha,1,T)+mu_a).*(repmat(gamma,N,1)+mu_g)-mu_g*mu_a) + sqrt(sg_e)*epsilon;           
                y = beta(1,1) + X*beta(2,1) + u;
                
                dyadic = 0;
               
            end
            
            
	   if design==5
                
                alpha = randn(N,1);
                gamma = randn(1,T);
                epsilon = randn(N,T);
                
                u = sqrt(sg_a*sg_g)*((repmat(alpha,1,T)+mu_a).*(repmat(gamma,N,1)+mu_g)-mu_g*mu_a) + sqrt(sg_e)*epsilon;           
                y = beta(1,1) + X*beta(2,1) + u;
                
                dyadic = 0;
               
            end


	    if design==6
                
                alpha = randn(N,1);
                gamma = randn(1,T);
                epsilon = randn(N,T);
                
                u = sqrt(sg_a*sg_g)*((repmat(alpha,1,T)+mu_a).*(repmat(gamma,N,1)+mu_g)-mu_g*mu_a) + sqrt(sg_e)*epsilon;           
                y = beta(1,1) + X*beta(2,1) + u;
                
                dyadic = 0;
               
            end
            
            
            
            
            X_mat = [ones(N*T,1) reshape(X,N*T,1)];
            y_mat = reshape(y,N*T,1);
            X_dd = X - repmat(mean(X,2),1,T) - repmat(mean(X,1),N,1) + mean(mean(X));
            y_dd = y - repmat(mean(y,2),1,T) - repmat(mean(y,1),N,1) + mean(mean(y));
            X_dd_mat = reshape(X_dd,N*T,1);
            y_dd_mat = reshape(y_dd,N*T,1);
            beta_LS = inv(X_mat'*X_mat)*X_mat'*y_mat;
            beta_DD = inv(X_dd_mat'*X_dd_mat)*X_dd_mat'*y_dd_mat;
            
            
            u_hat = y - beta_LS(1,1) - X*beta_LS(2,1);
            alpha_hat = mean(u_hat,2) - mean(mean(u_hat));
            gamma_hat = mean(u_hat,1) - mean(mean(u_hat));
            eps_hat = u_hat - repmat(alpha_hat,1,T) - repmat(gamma_hat,N,1) - mean(mean(u_hat));
        
            
            
            
            sigma2_e = var(reshape(eps_hat,N*T,1));
            sigma2_a = max(0,var(alpha_hat)-sigma2_e/T);
            sigma2_g = max(0,var(gamma_hat)-sigma2_e/N);
            
            
            
            
            
            
            mu4_e = sqrt(2)*max(0.1,sqrt(mean(mean(eps_hat.^4))-mean(mean(eps_hat)).^4));
            kappa_N = 1*log(N)*mu4_e;
            kappa_T = 1*log(T)*mu4_e;
            
            
            
            
            
            
            
            
                     
            
            
            
            
 
            
            kappa_N = 10*log(N)*mu4_e;
            kappa_T = 10*log(T)*mu4_e;
            
           
            
            
            swtch1 = T*sigma2_a>kappa_T;
            swtch2 = N*sigma2_g>kappa_N; 
            
            
            if oracle==1
                swtch1 = abs(mu_a) +abs(mu_g)>0;
                swtch2 = abs(mu_a) +abs(mu_g)>0;
                swtch1 = 1;
                swtch2 = 1;
            end
            
            
        
            
            [beta_LS,beta_DD,se_LS,se_LS_nosel,se_DD] = reg_coeffs(y,X,y_dd,X_dd,swtch1,swtch2);
                       
            
            y_LS_rep(b,1) = (beta_LS(2,1)-beta(2,1));
            t_LS_rep(b,1) = (beta_LS(2,1)-beta(2,1))/se_LS(2,1); 
            se_LS_rep(b,1) = se_LS(2,1);
            t_LS_rep_nosel(b,1) = (beta_LS(2,1)-beta(2,1))/se_LS_nosel(2,1);
            y_DD_rep(b,1) = (beta_DD(1,1)-beta(2,1));
            t_DD_rep(b,1) = (beta_DD(1,1)-beta(2,1))/se_DD(1,1);
            t_DD_rep_nosel(b,1) = (beta_DD(1,1)-beta(2,1))/se_DD(1,1);
            
            
            % bootstrap with model selection          
            
            lambda1 = swtch1*T*sigma2_a/(T*sigma2_a + sigma2_e);
            lambda2 = swtch2*N*sigma2_g/(N*sigma2_g + sigma2_e);
            
            
            [y_LS_bs,t_LS_bs,y_DD_bs,t_DD_bs] = twcl_bootstrap_reg(y,X,y_dd,X_dd,beta_LS,beta_DD,S_max,lambda1,lambda2,swtch1,swtch2,dyadic);
            y_LS_bs = sort(y_LS_bs);
            t_LS_bs = sort(t_LS_bs);
            y_DD_bs = sort(y_DD_bs);
            t_DD_bs = sort(t_DD_bs);
                      

            % bootstrap without model selection
            
            swtch1_nosel = 1;
            swtch2_nosel = 1;
            lambda1_nosel = T*sigma2_a/(T*sigma2_a + sigma2_e);
            lambda2_nosel = N*sigma2_g/(N*sigma2_g + sigma2_e);
            
            [y_LS_bs_nosel,t_LS_bs_nosel,y_DD_bs_nosel,t_DD_bs_nosel] = twcl_bootstrap_reg(y,X,y_dd,X_dd,beta_LS,beta_DD,S_max,lambda1_nosel,lambda2_nosel,swtch1_nosel,swtch2_nosel,dyadic);
            y_LS_nosel = sort(y_LS_bs_nosel);
            t_LS_nosel = sort(t_LS_bs_nosel);
            y_DD_nosel = sort(y_DD_bs_nosel);
            t_DD_nosel = sort(t_DD_bs_nosel);

            % conservative bootstrap
            
            qa_uniform = max(T*sigma2_a,kappa_N);
            qg_uniform = max(N*sigma2_g,kappa_T);
            
            lambda1_uniform = qa_uniform/(qa_uniform + sigma2_e)*(qa_uniform/T/sigma2_a);
            lambda2_uniform = qg_uniform/(qg_uniform + sigma2_e)*(qg_uniform/N/sigma2_g);
            
            [y_LS_uniform,t_LS_uniform,y_DD_uniform,t_DD_uniform] = twcl_bootstrap_reg(y,X,y_dd,X_dd,beta_LS,beta_DD,S_max,lambda1_uniform,lambda2_uniform,swtch1,swtch2,dyadic);
            y_LS_uniform = sort(y_LS_uniform);
            t_LS_uniform = sort(t_LS_uniform);
            y_DD_uniform = sort(y_DD_uniform);
            t_DD_uniform = sort(t_DD_uniform);
            
    
            y_LS_bs = sort(y_LS_bs);
            pct_005_LS_bs = y_LS_bs(round(S_max/200));
            pct_01_LS_bs = y_LS_bs(round(S_max/100));
            pct_025_LS_bs = y_LS_bs(round(S_max/40));
            pct_05_LS_bs = y_LS_bs(round(S_max/20));
            pct_10_LS_bs = y_LS_bs(round(S_max/10));
            pct_50_LS_bs = y_LS_bs(round(S_max/2));
            pct_90_LS_bs = y_LS_bs(round(S_max*9/10));
            pct_95_LS_bs = y_LS_bs(round(S_max*19/20));
            pct_975_LS_bs = y_LS_bs(round(S_max*39/40));
            pct_99_LS_bs = y_LS_bs(round(S_max*99/100));
            pct_995_LS_bs = y_LS_bs(round(S_max*199/200));
            pct_bs_LS_rep(b,:) = [pct_01_LS_bs pct_025_LS_bs pct_05_LS_bs pct_10_LS_bs pct_50_LS_bs pct_90_LS_bs pct_95_LS_bs pct_975_LS_bs pct_99_LS_bs];
                        
            y_DD_bs = sort(y_DD_bs);
            pct_005_DD_bs = y_DD_bs(round(S_max/200));
            pct_01_DD_bs = y_DD_bs(round(S_max/100));
            pct_025_DD_bs = y_DD_bs(round(S_max/40));
            pct_05_DD_bs = y_DD_bs(round(S_max/20));
            pct_10_DD_bs = y_DD_bs(round(S_max/10));
            pct_50_DD_bs = y_DD_bs(round(S_max/2));
            pct_90_DD_bs = y_DD_bs(round(S_max*9/10));
            pct_95_DD_bs = y_DD_bs(round(S_max*19/20));
            pct_975_DD_bs = y_DD_bs(round(S_max*39/40));
            pct_99_DD_bs = y_DD_bs(round(S_max*99/100));
            pct_995_DD_bs = y_DD_bs(round(S_max*199/200));
            pct_bs_DD_rep(b,:) = [pct_01_DD_bs pct_025_DD_bs pct_05_DD_bs pct_10_DD_bs pct_50_DD_bs pct_90_DD_bs pct_95_DD_bs pct_975_DD_bs pct_99_DD_bs];

            t_LS_bs = sort(t_LS_bs);
            pct_005_LS_bspiv = t_LS_bs(round(S_max/200));
            pct_01_LS_bspiv = t_LS_bs(round(S_max/100));
            pct_025_LS_bspiv = t_LS_bs(round(S_max/40));
            pct_05_LS_bspiv = t_LS_bs(round(S_max/20));
            pct_10_LS_bspiv = t_LS_bs(round(S_max/10));
            pct_50_LS_bspiv = t_LS_bs(round(S_max/2));
            pct_90_LS_bspiv = t_LS_bs(round(S_max*9/10));
            pct_95_LS_bspiv = t_LS_bs(round(S_max*19/20));
            pct_975_LS_bspiv = t_LS_bs(round(S_max*39/40));
            pct_99_LS_bspiv = t_LS_bs(round(S_max*99/100));
            pct_995_LS_bspiv = t_LS_bs(round(S_max*199/200));
            pct_bspiv_LS_rep(b,:) = [pct_01_LS_bspiv pct_025_LS_bspiv pct_05_LS_bspiv pct_10_LS_bspiv pct_50_LS_bspiv pct_90_LS_bspiv pct_95_LS_bspiv pct_975_LS_bspiv pct_99_LS_bspiv];
            
            t_DD_bs = sort(t_DD_bs);
            pct_005_DD_bspiv = t_DD_bs(round(S_max/200));
            pct_01_DD_bspiv = t_DD_bs(round(S_max/100));
            pct_025_DD_bspiv = t_DD_bs(round(S_max/40));
            pct_05_DD_bspiv = t_DD_bs(round(S_max/20));
            pct_10_DD_bspiv = t_DD_bs(round(S_max/10));
            pct_50_DD_bspiv = t_DD_bs(round(S_max/2));
            pct_90_DD_bspiv = t_DD_bs(round(S_max*9/10));
            pct_95_DD_bspiv = t_DD_bs(round(S_max*19/20));
            pct_975_DD_bspiv = t_DD_bs(round(S_max*39/40));
            pct_99_DD_bspiv = t_DD_bs(round(S_max*99/100));
            pct_995_DD_bspiv = t_DD_bs(round(S_max*199/200));
            pct_bspiv_DD__rep(b,:) = [pct_01_DD_bspiv pct_025_DD_bspiv pct_05_DD_bspiv pct_10_DD_bspiv pct_50_DD_bspiv pct_90_DD_bspiv pct_95_DD_bspiv pct_975_DD_bspiv pct_99_DD_bspiv];
            
            y_LS_nosel = sort(y_LS_nosel);
            pct_005_LS_nosel = y_LS_nosel(round(S_max/200));
            pct_01_LS_nosel = y_LS_nosel(round(S_max/100));
            pct_025_LS_nosel = y_LS_nosel(round(S_max/40));
            pct_05_LS_nosel = y_LS_nosel(round(S_max/20));
            pct_10_LS_nosel = y_LS_nosel(round(S_max/10));
            pct_50_LS_nosel = y_LS_nosel(round(S_max/2));
            pct_90_LS_nosel = y_LS_nosel(round(S_max*9/10));
            pct_95_LS_nosel = y_LS_nosel(round(S_max*19/20));
            pct_975_LS_nosel = y_LS_nosel(round(S_max*39/40));
            pct_99_LS_nosel = y_LS_nosel(round(S_max*99/100));
            pct_995_LS_nosel = y_LS_nosel(round(S_max*199/200));
            pct_nosel_LS_rep(b,:) = [pct_01_LS_nosel pct_025_LS_nosel pct_05_LS_nosel pct_10_LS_nosel pct_50_LS_nosel pct_90_LS_nosel pct_95_LS_nosel pct_975_LS_nosel pct_99_LS_nosel];
            
            y_DD_nosel = sort(y_DD_nosel);
            pct_005_DD_nosel = y_DD_nosel(round(S_max/200));
            pct_01_DD_nosel = y_DD_nosel(round(S_max/100));
            pct_025_DD_nosel = y_DD_nosel(round(S_max/40));
            pct_05_DD_nosel = y_DD_nosel(round(S_max/20));
            pct_10_DD_nosel = y_DD_nosel(round(S_max/10));
            pct_50_DD_nosel = y_DD_nosel(round(S_max/2));
            pct_90_DD_nosel = y_DD_nosel(round(S_max*9/10));
            pct_95_DD_nosel = y_DD_nosel(round(S_max*19/20));
            pct_975_DD_nosel = y_DD_nosel(round(S_max*39/40));
            pct_99_DD_nosel = y_DD_nosel(round(S_max*99/100));
            pct_995_DD_nosel = y_DD_nosel(round(S_max*199/200));
            pct_nosel_DD_rep(b,:) = [pct_01_DD_nosel pct_025_DD_nosel pct_05_DD_nosel pct_10_DD_nosel pct_50_DD_nosel pct_90_DD_nosel pct_95_DD_nosel pct_975_DD_nosel pct_99_DD_nosel];
            
            t_LS_nosel = sort(t_LS_nosel);
            pct_005_LS_noselpiv = t_LS_nosel(round(S_max/200));
            pct_01_LS_noselpiv = t_LS_nosel(round(S_max/100));
            pct_025_LS_noselpiv = t_LS_nosel(round(S_max/40));
            pct_05_LS_noselpiv = t_LS_nosel(round(S_max/20));
            pct_10_LS_noselpiv = t_LS_nosel(round(S_max/10));
            pct_50_LS_noselpiv = t_LS_nosel(round(S_max/2));
            pct_90_LS_noselpiv = t_LS_nosel(round(S_max*9/10));
            pct_95_LS_noselpiv = t_LS_nosel(round(S_max*19/20));
            pct_975_LS_noselpiv = t_LS_nosel(round(S_max*39/40));
            pct_99_LS_noselpiv = t_LS_nosel(round(S_max*99/100));
            pct_995_LS_noselpiv = t_LS_nosel(round(S_max*199/200));
            pct_noselpiv_LS_rep(b,:) = [pct_01_LS_noselpiv pct_025_LS_noselpiv pct_05_LS_noselpiv pct_10_LS_noselpiv pct_50_LS_noselpiv pct_90_LS_noselpiv pct_95_LS_noselpiv pct_975_LS_noselpiv pct_99_LS_noselpiv];
            
            t_DD_nosel = sort(t_DD_nosel);
            pct_005_DD_noselpiv = t_DD_nosel(round(S_max/200));
            pct_01_DD_noselpiv = t_DD_nosel(round(S_max/100));
            pct_025_DD_noselpiv = t_DD_nosel(round(S_max/40));
            pct_05_DD_noselpiv = t_DD_nosel(round(S_max/20));
            pct_10_DD_noselpiv = t_DD_nosel(round(S_max/10));
            pct_50_DD_noselpiv = t_DD_nosel(round(S_max/2));
            pct_90_DD_noselpiv = t_DD_nosel(round(S_max*9/10));
            pct_95_DD_noselpiv = t_DD_nosel(round(S_max*19/20));
            pct_975_DD_noselpiv = t_DD_nosel(round(S_max*39/40));
            pct_99_DD_noselpiv = t_DD_nosel(round(S_max*99/100));
            pct_995_DD_noselpiv = t_DD_nosel(round(S_max*199/200));
            pct_noselpiv_DD_rep(b,:) = [pct_01_DD_noselpiv pct_025_DD_noselpiv pct_05_DD_noselpiv pct_10_DD_noselpiv pct_50_DD_noselpiv pct_90_DD_noselpiv pct_95_DD_noselpiv pct_975_DD_noselpiv pct_99_DD_noselpiv];
            
            t_LS_uniform = sort(t_LS_uniform);
            pct_005_LS_uniform = t_LS_uniform(round(S_max/200));
            pct_01_LS_uniform = t_LS_uniform(round(S_max/100));
            pct_025_LS_uniform = t_LS_uniform(round(S_max/40));
            pct_05_LS_uniform = t_LS_uniform(round(S_max/20));
            pct_10_LS_uniform = t_LS_uniform(round(S_max/10));
            pct_50_LS_uniform = t_LS_uniform(round(S_max/2));
            pct_90_LS_uniform = t_LS_uniform(round(S_max*9/10));
            pct_95_LS_uniform = t_LS_uniform(round(S_max*19/20));
            pct_975_LS_uniform = t_LS_uniform(round(S_max*39/40));
            pct_99_LS_uniform = t_LS_uniform(round(S_max*99/100));
            pct_995_LS_uniform = t_LS_uniform(round(S_max*199/200));
            pct_uniform_LS_rep(b,:) = [pct_01_LS_uniform pct_025_LS_uniform pct_05_LS_uniform pct_10_LS_uniform pct_50_LS_uniform pct_90_LS_uniform pct_95_LS_uniform pct_975_LS_uniform pct_99_LS_uniform];
             
            t_DD_uniform = sort(t_DD_uniform);
            pct_005_DD_uniform = t_DD_uniform(round(S_max/200));
            pct_01_DD_uniform = t_DD_uniform(round(S_max/100));
            pct_025_DD_uniform = t_DD_uniform(round(S_max/40));
            pct_05_DD_uniform = t_DD_uniform(round(S_max/20));
            pct_10_DD_uniform = t_DD_uniform(round(S_max/10));
            pct_50_DD_uniform = t_DD_uniform(round(S_max/2));
            pct_90_DD_uniform = t_DD_uniform(round(S_max*9/10));
            pct_95_DD_uniform = t_DD_uniform(round(S_max*19/20));
            pct_975_DD_uniform = t_DD_uniform(round(S_max*39/40));
            pct_99_DD_uniform = t_DD_uniform(round(S_max*99/100));
            pct_995_DD_uniform = t_DD_uniform(round(S_max*199/200));
            pct_uniform_DD_rep(b,:) = [pct_01_DD_uniform pct_025_DD_uniform pct_05_DD_uniform pct_10_DD_uniform pct_50_DD_uniform pct_90_DD_uniform pct_95_DD_uniform pct_975_DD_uniform pct_99_DD_uniform];
            
                                
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Evaluate coverage and confidence interval length %
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            lw_ix = ceil(S_max/200);
            up_ix = ceil(S_max*199/200)+1;
            
 
            t_LS_bs_sym = sort(abs(t_LS_bs));
            crit_LS_sym_bs = t_LS_bs_sym(95*S_max/100);
            t_LS_nosel_sym = sort(abs(t_LS_nosel));
            crit_LS_sym_nosel = t_LS_nosel_sym(95*S_max/100);
            
            t_DD_bs_sym = sort(abs(t_DD_bs));
            crit_DD_sym_bs = t_DD_bs_sym(95*S_max/100);
            t_DD_nosel_sym = sort(abs(t_DD_nosel));
            crit_DD_sym_nosel = t_DD_nosel_sym(95*S_max/100);
                      
            rej_LS_gauss = abs(t_LS_rep(b,1))>=1.9599;
            rej_LS_bspiv = (t_LS_rep(b,1)<=-pct_975_LS_bspiv)+(t_LS_rep(b,1)>=-pct_025_LS_bspiv);
            rej_LS_sym_bs = abs(t_LS_rep(b,1))>=crit_LS_sym_bs;
            rej_LS_uniform = (t_LS_rep(b,1)<=-pct_975_LS_uniform)+(t_LS_rep(b,1)>=-pct_025_LS_uniform);
  
            rej_DD_gauss = abs(t_DD_rep(b,1))>=1.9599;
            rej_DD_bspiv = (t_DD_rep(b,1)<=-pct_975_DD_bspiv)+(t_DD_rep(b,1)>=-pct_025_DD_bspiv);
            rej_DD_sym_bs = abs(t_DD_rep(b,1))>=crit_DD_sym_bs;

            rej_all(b,:) = [rej_LS_gauss rej_LS_bspiv rej_LS_sym_bs rej_LS_uniform rej_DD_gauss rej_DD_bspiv rej_DD_sym_bs]



            
            
            t_LS_alt1(b,1) = (beta_LS(2,1) - beta(2,1)+0.1/sqrt(N))/se_LS(2,1);
            t_DD_alt1(b,1) = (beta_DD(1,1) - beta(2,1)+0.1/sqrt(N))/se_DD(1,1);
            alt1_LS_gauss = abs(t_LS_alt1(b,1))>=1.9599;
            alt1_LS_bspiv = (t_LS_alt1(b,1)<=-pct_975_LS_bspiv)+(t_LS_alt1(b,1)>=-pct_025_LS_bspiv);
            alt1_LS_sym_bs = abs(t_LS_alt1(b,1))>=crit_LS_sym_bs;
            alt1_LS_uniform = (t_LS_alt1(b,1)<=-pct_975_LS_uniform)+(t_LS_alt1(b,1)>=-pct_025_LS_uniform);
            alt1_DD_gauss = abs(t_DD_alt1(b,1))>=1.9599;
            alt1_DD_bspiv = (t_DD_alt1(b,1)<=-pct_975_DD_bspiv)+(t_DD_alt1(b,1)>=-pct_025_DD_bspiv);
            alt1_DD_sym_bs = abs(t_DD_alt1(b,1))>=crit_DD_sym_bs;
            alt1_all(b,:) = [alt1_LS_gauss alt1_LS_bspiv alt1_LS_sym_bs alt1_LS_uniform alt1_DD_gauss alt1_DD_bspiv alt1_DD_sym_bs];
            
            
            t_LS_alt2(b,1) = (beta_LS(2,1) - beta(2,1)+1/sqrt(N*T))/se_LS(2,1);
            t_DD_alt2(b,1) = (beta_DD(1,1) - beta(2,1)+1/sqrt(N*T))/se_DD(1,1);
            alt2_LS_gauss = abs(t_LS_alt2(b,1))>=1.9599;
            alt2_LS_bspiv = (t_LS_alt2(b,1)<=-pct_975_LS_bspiv)+(t_LS_alt2(b,1)>=-pct_025_LS_bspiv);
            alt2_LS_sym_bs = abs(t_LS_alt2(b,1))>=crit_LS_sym_bs;
            alt2_LS_uniform = (t_LS_alt2(b,1)<=-pct_975_LS_uniform)+(t_LS_alt2(b,1)>=-pct_025_LS_uniform);
            alt2_DD_gauss = abs(t_DD_alt2(b,1))>=1.9599;
            alt2_DD_bspiv = (t_DD_alt2(b,1)<=-pct_975_DD_bspiv)+(t_DD_alt2(b,1)>=-pct_025_DD_bspiv);
            alt2_DD_sym_bs = abs(t_DD_alt2(b,1))>=crit_DD_sym_bs;
            alt2_all(b,:) = [alt2_LS_gauss alt2_LS_bspiv alt2_LS_sym_bs alt2_LS_uniform alt2_DD_gauss alt2_DD_bspiv alt2_DD_sym_bs];
            
            
 
  
end
        


        pct_gauss_rep = pct_gauss_rep;
        
       
        t_LS_rep = sort(t_LS_rep);
        pct_01_LS_true = t_LS_rep(round(B_max/100));
        pct_025_LS_true = t_LS_rep(round(B_max/40));
        pct_05_LS_true = t_LS_rep(round(B_max/20));
        pct_10_LS_true = t_LS_rep(round(B_max/10));
        pct_50_LS_true = t_LS_rep(round(B_max/2));
        pct_90_LS_true = t_LS_rep(round(B_max*9/10));
        pct_95_LS_true = t_LS_rep(round(B_max*19/20));
        pct_975_LS_true = t_LS_rep(round(B_max*39/40));
        pct_99_LS_true = t_LS_rep(round(B_max*99/100));
        pct_LS_true = [pct_01_LS_true pct_025_LS_true pct_05_LS_true pct_10_LS_true pct_50_LS_true pct_90_LS_true pct_95_LS_true pct_975_LS_true pct_99_LS_true];
        
        t_DD_rep = sort(t_DD_rep);
        pct_01_DD_true = t_DD_rep(round(B_max/100));
        pct_025_DD_true = t_DD_rep(round(B_max/40));
        pct_05_DD_true = t_DD_rep(round(B_max/20));
        pct_10_DD_true = t_DD_rep(round(B_max/10));
        pct_50_DD_true = t_DD_rep(round(B_max/2));
        pct_90_DD_true = t_DD_rep(round(B_max*9/10));
        pct_95_DD_true = t_DD_rep(round(B_max*19/20));
        pct_975_DD_true = t_DD_rep(round(B_max*39/40));
        pct_99_DD_true = t_DD_rep(round(B_max*99/100));
        pct_DD_true = [pct_01_DD_true pct_025_DD_true pct_05_DD_true pct_10_DD_true pct_50_DD_true pct_90_DD_true pct_95_DD_true pct_975_DD_true pct_99_DD_true];
        
        
        
        
        
end

