function [y_LS_bs,t_LS_bs,y_DD_bs,t_DD_bs] = twcl_bootstrap_reg(y,X,y_dd,X_dd,beta_LS,beta_DD,S_max,lambda1,lambda2,swtch1,swtch2,dyadic)
        
    [N,T] = size(y);
            
    u_hat = y - beta_LS(1,1) - X*beta_LS(2,1); 
    w_hat  = y_dd - X_dd*beta_DD;
    
    alpha_hat = mean(u_hat,2) - mean(mean(u_hat));
    gamma_hat = mean(u_hat,1) - mean(mean(u_hat));            
    eps_hat = u_hat - repmat(alpha_hat,1,T) - repmat(gamma_hat,N,1) - mean(mean(u_hat));
    
      
            
    y_LS_bs = zeros(S_max,1);
    t_LS_bs = zeros(S_max,1);
    y_DD_bs = zeros(S_max,1);
    t_DD_bs = zeros(S_max,1);

            
       
    for s = 1:S_max    
                  
        i_vec = ceil(N*rand(N,1));
        alpha_star = (alpha_hat(i_vec)-mean(alpha_hat));  
        t_vec = ceil(T*rand(T,1));
        gamma_star = (gamma_hat(t_vec)-mean(gamma_hat));
        

        
        
        omega_e1 = gamrnd(4,0.5,N,1)-2;
        omega_e2 = gamrnd(4,0.5,1,T)-2;
        
        omega_e = omega_e1*omega_e2;
        epsilon_star = omega_e.*(eps_hat-mean(mean(eps_hat))); 
        
        
        u_star = sqrt(lambda1)*repmat(alpha_star,1,T) + sqrt(lambda2)*repmat(gamma_star,N,1)+epsilon_star;
        w_dd_star = omega_e.*(w_hat-mean(mean(w_hat))); 
        
        
        if dyadic==1
            u_star = u_star - mean(alpha_star.^2);
        end
        
        y_star = beta_LS(1,1) + X*beta_LS(2,1) + u_star;
        y_dd_star = X_dd*beta_DD + w_dd_star;
        
        
        [beta_LS_star,beta_DD_star,se_LS_star,se_LS_nosel_star,se_DD_star] = reg_coeffs(y_star,X,y_dd_star,X_dd,swtch1,swtch2);
        
        

    y_LS_bs(s,1) = (beta_LS_star(2,1)-beta_LS(2,1));
    t_LS_bs(s,1) = (beta_LS_star(2,1)-beta_LS(2,1))/se_LS_star(2,1);
    y_DD_bs(s,1) = (beta_DD_star(1,1)-beta_DD(1,1));
    t_DD_bs(s,1) = (beta_DD_star(1,1)-beta_DD(1,1))/se_DD_star(1,1);
    

            
    end
            

            
end