function [y_bs,t_bs] = pigeonhole(y,sigma2_hat,S_max,dyadic)
        
    [N,T] = size(y);
    y_bs = zeros(S_max,1);
    t_bs = zeros(S_max,1);
    
    for s = 1:S_max
        
        y_tilde = y;
        
        
        M_i = binornd(N,1/N,N,1); 
        M_t = binornd(T,1/T,1,T);
        
        if dyadic==1
            M_t = M_i';
        end
        
        y_star = (M_i*M_t).*y_tilde;
        N_star = sum(M_i);
        T_star = sum(M_t);
        
        y_bar = mean(mean(y_star))*(N*T/N_star/T_star); 
        
        
        alpha_star = mean(y_star,2)*T/T_star - y_bar;
        gamma_star = mean(y_star,1)*N/N_star - y_bar;
        eps_star = y_star - repmat(alpha_star,1,T) - repmat(gamma_star,N,1) - y_bar;
        
        sigma2_e_star = var(reshape(eps_star,N*T,1));
        sigma2_a_star = max(var(alpha_star) - sigma2_e_star/T_star,0);
        sigma2_g_star = max(var(gamma_star,[],2) - sigma2_e_star/N_star,0);        
        
        sigma2_star = T_star*sigma2_a_star/2 + N_star*sigma2_g_star/2 + sigma2_e_star/4;
        
        y_bs(s,:) = (y_bar-mean(mean(y)))*sqrt(N_star*T_star/sigma2_hat);
        t_bs(s,:) = (y_bar-mean(mean(y)))*sqrt(N_star*T_star/sigma2_star);
        
    end
    
    y_bs = sort(y_bs);
    t_bs = sort(t_bs);
end