function [y_bs,t_bs] = pigeonhole2(y,sigma2_hat,S_max,dyadic)
        
    [N,T] = size(y);
    y_bs = zeros(S_max,1);
    t_bs = zeros(S_max,1);
    
    for s = 1:S_max
        
        row_sel = ceil(N*rand(N,1));
        col_sel = ceil(T*rand(1,T));
        
        y_rw_sel = y(row_sel,:);
        y_star = y_rw_sel(:,col_sel);
        
        if dyadic==1
            y_rw_sel = y(row_sel,:);
            y_star = y_rw_sel(:,row_sel');
        end
        
       
        
        y_bar = mean(mean(y_star)); 
        
        
        alpha_star = mean(y_star,2) - y_bar;
        gamma_star = mean(y_star,1) - y_bar;
        eps_star = y_star - repmat(alpha_star,1,T) - repmat(gamma_star,N,1) - y_bar;
        
        sigma2_e_star = var(reshape(eps_star,N*T,1));
        sigma2_a_star = max(var(alpha_star) - sigma2_e_star/T,0);
        sigma2_g_star = max(var(gamma_star,[],2) - sigma2_e_star/N,0);        
        
        sigma2_star = T*sigma2_a_star + N*sigma2_g_star + sigma2_e_star;
        
        y_bs(s,:) = (y_bar-mean(mean(y)))*sqrt(N*T/sigma2_hat);
        t_bs(s,:) = (y_bar-mean(mean(y)))*sqrt(N*T/sigma2_star);
        
    end
    
    y_bs = sort(y_bs);
    t_bs = sort(t_bs);
end