function [std_err,rej_rate,os_rej,pct_all,pct_err_all,mse_all ,rej_gauss_gph,rej_subs_gph,rej_bs_gph,rej_bspiv_gph] = simulate_1pct(N,T,B_max,S_max,design,oracle,mu_a,mu_g,sg_a,sg_g,sg_e)


y_rep = zeros(B_max,1);
t_rep = zeros(B_max,1);
var_an = zeros(B_max,1);
var_bs = zeros(B_max,1);

rej_all = zeros(B_max,11);
one_side_all = zeros(B_max,12);

pct_gauss_rep = zeros(B_max,9); 
pct_subs_rep = zeros(B_max,9);
pct_bs_rep = zeros(B_max,9);
pct_bspiv_rep = zeros(B_max,9);

rej_gauss_gph = zeros(B_max,50);
rej_subs_gph = zeros(B_max,50);
rej_bs_gph = zeros(B_max,50);
rej_bspiv_gph = zeros(B_max,50);


parfor b = 1:B_max
       

            
            if design==1
                
                alpha = randn(N,1);
                gamma = randn(1,T);
                epsilon = randn(N,T);
                
                y = sqrt(sg_a)*repmat(alpha,1,T) + sqrt(sg_g)*repmat(gamma,N,1) + sqrt(sg_e)*epsilon;
                dyadic = 0;
              
            end
            
            if design==2
                
                lgn_scale = 0.5;
                %lgn_scale = 0.8;
                lgn_var = (exp(lgn_scale^2)-1)*exp(lgn_scale^2);
                alpha = 0*randn(N,1) + 1*(exp(lgn_scale*randn(N,1))- exp(lgn_scale^2/2))/sqrt(lgn_var);          
                gamma = randn(1,T);
                epsilon = randn(N,T);
                
                y = sqrt(sg_a)*repmat(alpha,1,T) + sqrt(sg_g)*repmat(gamma,N,1) + sqrt(sg_e)*epsilon;
            
                dyadic = 0;
          
            end
            
            if design==3
                
                U = rand(N,1)>0.9;
                alpha = (0.5 + 1.5*U).*randn(N,1);
                U = rand(1,T)>0.9;
                gamma = (0.5 + 1.5*U).*randn(1,T);
                            
                epsilon = randn(N,T);
                
                y = sqrt(sg_a)*repmat(alpha,1,T) + sqrt(sg_g)*repmat(gamma,N,1) + sqrt(sg_e)*epsilon;
            
                dyadic = 0;
               
            
            end        
            
            if design==4
                
                alpha = randn(N,1);
                gamma = randn(1,T);
                epsilon = randn(N,T);
                
                y = sqrt(sg_a*sg_g)*((repmat(alpha,1,T)+mu_a).*(repmat(gamma,N,1)+mu_g)-mu_g*mu_a) + sqrt(sg_e)*epsilon;
            
                dyadic = 0;
               
            end
            
            
            if design==5
                
                alpha = randn(N,1);
                epsilon = randn(N,N);
                
                y = sg_a*((repmat(alpha,1,N)+mu_a).*(repmat(alpha',N,1)+mu_a)-mu_a^2-1/N)/sqrt(2) + sqrt(sg_e)*epsilon;
            
                dyadic = 1;
              
            end
            
            
            
            alpha_hat = mean(y,2) - mean(mean(y));
            gamma_hat = mean(y,1) - mean(mean(y));
            eps_hat = y - repmat(alpha_hat,1,T) - repmat(gamma_hat,N,1) - mean(mean(y));
        
            
            
            sigma2_e = var(reshape(eps_hat,N*T,1));
            sigma2_a = max(0,var(alpha_hat)-sigma2_e/T);
            sigma2_g = max(0,var(gamma_hat)-sigma2_e/N);
            
            
            if oracle==1
                sigma2_e = sg_a*sg_g;
                sigma2_a = 0;
                sigma2_g = 0;
            end
            
 
            kappa_N = 0.05*log(N);
            kappa_T = 0.05*log(T);
            swtch1 = T*sigma2_a>kappa_T;
            swtch2 = N*sigma2_g>kappa_N;           
            
            if oracle==1
                kappa_N = 0;
                kappa_T = 0;
                swtch1 = 0;
                swtch2 = 0;
            end
                    
            sigma2_hat = swtch1*T*sigma2_a + swtch2*N*sigma2_g + sigma2_e;
            sigma2_nosel = T*sigma2_a + N*sigma2_g + sigma2_e;
                
            
            
            

            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Generate statistics and bootstrap samples %
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            y_rep(b,1) = mean(mean(y));
            t_rep(b,1) = mean(mean(y))*sqrt(N*T/sigma2_hat);
            t_rep_nosel(b,1) = mean(mean(y))*sqrt(N*T/sigma2_nosel);
            
            
            
            
            % bootstrap with model selection          
            
            lambda1 = swtch1*T*sigma2_a/(T*sigma2_a + sigma2_e);
            lambda2 = swtch2*N*sigma2_g/(N*sigma2_g + sigma2_e);
            
            [y_bs,t_bs,sig2_star,sig2_estar] = twcl_bootstrap(y,sigma2_hat,S_max,lambda1,lambda2,swtch1,swtch2,dyadic);
            y_bs = sort(y_bs);
            t_bs = sort(t_bs);
            if oracle==1
                t_bs = sort(y_bs);
            end
                      

            % bootstrap without model selection
            
            swtch1_nosel = 1;
            swtch2_nosel = 1;
            lambda1_nosel = T*sigma2_a/(T*sigma2_a + sigma2_e);
            lambda2_nosel = N*sigma2_g/(N*sigma2_g + sigma2_e);
            
            [y_nosel,t_nosel,sig2_star_nosel,sig2_estar_nosel] = twcl_bootstrap(y,sigma2_nosel,S_max,lambda1_nosel,lambda2_nosel,1,1,dyadic);           
            y_nosel = sort(y_nosel);
            t_nosel = sort(t_nosel);
            if oracle==1
                t_nosel = sort(y_nosel);
            end
            
            % conservative bootstrap
            
            qa_uniform = max(T*sigma2_a,kappa_N);
            qg_uniform = max(N*sigma2_g,kappa_T);
            
            lambda1_uniform = qa_uniform/(qa_uniform + sigma2_e)*(qa_uniform/T/sigma2_a);
            lambda2_uniform = qg_uniform/(qg_uniform + sigma2_e)*(qg_uniform/N/sigma2_g);
            
            [y_uniform,t_uniform,sig2_star,sig2_estar] = twcl_bootstrap(y,sigma2_hat,S_max,lambda1_uniform,lambda2_uniform,swtch1,swtch2,dyadic);
            y_uniform = sort(y_uniform);
            t_uniform = sort(t_uniform);
            if oracle==1
                t_uniform = sort(y_uniform);
            end

            
            % pigeonhole bootstrap
            
            [y_pgbs,t_pgbs] = pigeonhole2(y,sigma2_nosel,S_max,dyadic);
            
         
            
            
            
            % subsampling
            
            Nm = ceil(N^0.33);
            Tm = ceil(T^0.33);
            sigma2_subs = swtch1*Tm*sigma2_a + swtch2*Nm*sigma2_g + sigma2_e;
            [y_subs,t_subs] = twcl_subsample(y,sigma2_subs,S_max,Nm,Tm,swtch1,swtch2,dyadic);
            y_subs = sort(y_subs);
            t_subs = sort(t_subs);
            if oracle==1
                t_subs = sort(y_subs);
            end
   
            
   
            
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Construct critical values and percentiles %
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            
            pct_005_subs = y_subs(ceil(S_max/200));
            pct_01_subs = y_subs(ceil(S_max/100));
            pct_025_subs = y_subs(ceil(S_max/40));
            pct_05_subs = y_subs(ceil(S_max/20));
            pct_10_subs = y_subs(ceil(S_max/10));
            pct_50_subs = y_subs(ceil(S_max/2));
            pct_90_subs = y_subs(ceil(S_max*9/10));
            pct_95_subs = y_subs(ceil(S_max*19/20));
            pct_975_subs = y_subs(ceil(S_max*39/40));
            pct_99_subs = y_subs(ceil(S_max*99/100));
            pct_995_subs = y_subs(ceil(S_max*199/200));
            pct_subs_rep(b,:) = [pct_01_subs pct_025_subs pct_05_subs pct_10_subs pct_50_subs pct_90_subs pct_95_subs pct_975_subs pct_99_subs];
            
                     
            pct_005_bs = y_bs(round(S_max/200));
            pct_01_bs = y_bs(round(S_max/100));
            pct_025_bs = y_bs(round(S_max/40));
            pct_05_bs = y_bs(round(S_max/20));
            pct_10_bs = y_bs(round(S_max/10));
            pct_50_bs = y_bs(round(S_max/2));
            pct_90_bs = y_bs(round(S_max*9/10));
            pct_95_bs = y_bs(round(S_max*19/20));
            pct_975_bs = y_bs(round(S_max*39/40));
            pct_99_bs = y_bs(round(S_max*99/100));
            pct_995_bs = y_bs(round(S_max*199/200));
            pct_bs_rep(b,:) = [pct_01_bs pct_025_bs pct_05_bs pct_10_bs pct_50_bs pct_90_bs pct_95_bs pct_975_bs pct_99_bs];
            
            pct_005_bspiv = t_bs(round(S_max/200));
            pct_01_bspiv = t_bs(round(S_max/100));
            pct_025_bspiv = t_bs(round(S_max/40));
            pct_05_bspiv = t_bs(round(S_max/20));
            pct_10_bspiv = t_bs(round(S_max/10));
            pct_50_bspiv = t_bs(round(S_max/2));
            pct_90_bspiv = t_bs(round(S_max*9/10));
            pct_95_bspiv = t_bs(round(S_max*19/20));
            pct_975_bspiv = t_bs(round(S_max*39/40));
            pct_99_bspiv = t_bs(round(S_max*99/100));
            pct_995_bspiv = t_bs(round(S_max*199/200));
            pct_bspiv_rep(b,:) = [pct_01_bspiv pct_025_bspiv pct_05_bspiv pct_10_bspiv pct_50_bspiv pct_90_bspiv pct_95_bspiv pct_975_bspiv pct_99_bspiv];
            
            
            pct_005_nosel = y_nosel(round(S_max/200));
            pct_01_nosel = y_nosel(round(S_max/100));
            pct_025_nosel = y_nosel(round(S_max/40));
            pct_05_nosel = y_nosel(round(S_max/20));
            pct_10_nosel = y_nosel(round(S_max/10));
            pct_50_nosel = y_nosel(round(S_max/2));
            pct_90_nosel = y_nosel(round(S_max*9/10));
            pct_95_nosel = y_nosel(round(S_max*19/20));
            pct_975_nosel = y_nosel(round(S_max*39/40));
            pct_99_nosel = y_nosel(round(S_max*99/100));
            pct_995_nosel = y_nosel(round(S_max*199/200));
            pct_nosel_rep(b,:) = [pct_01_nosel pct_025_nosel pct_05_nosel pct_10_nosel pct_50_nosel pct_90_nosel pct_95_nosel pct_975_nosel pct_99_nosel];
            
            pct_005_noselpiv = t_nosel(round(S_max/200));
            pct_01_noselpiv = t_nosel(round(S_max/100));
            pct_025_noselpiv = t_nosel(round(S_max/40));
            pct_05_noselpiv = t_nosel(round(S_max/20));
            pct_10_noselpiv = t_nosel(round(S_max/10));
            pct_50_noselpiv = t_nosel(round(S_max/2));
            pct_90_noselpiv = t_nosel(round(S_max*9/10));
            pct_95_noselpiv = t_nosel(round(S_max*19/20));
            pct_975_noselpiv = t_nosel(round(S_max*39/40));
            pct_99_noselpiv = t_nosel(round(S_max*99/100));
            pct_995_noselpiv = t_nosel(round(S_max*199/200));
            pct_noselpiv_rep(b,:) = [pct_01_noselpiv pct_025_noselpiv pct_05_noselpiv pct_10_noselpiv pct_50_noselpiv pct_90_noselpiv pct_95_noselpiv pct_975_noselpiv pct_99_noselpiv];
            
            pct_005_uniform = t_uniform(round(S_max/200));
            pct_01_uniform = t_uniform(round(S_max/100));
            pct_025_uniform = t_uniform(round(S_max/40));
            pct_05_uniform = t_uniform(round(S_max/20));
            pct_10_uniform = t_uniform(round(S_max/10));
            pct_50_uniform = t_uniform(round(S_max/2));
            pct_90_uniform = t_uniform(round(S_max*9/10));
            pct_95_uniform = t_uniform(round(S_max*19/20));
            pct_975_uniform = t_uniform(round(S_max*39/40));
            pct_99_uniform = t_uniform(round(S_max*99/100));
            pct_995_uniform = t_uniform(round(S_max*199/200));
            pct_uniform_rep(b,:) = [pct_01_uniform pct_025_uniform pct_05_uniform pct_10_uniform pct_50_uniform pct_90_uniform pct_95_uniform pct_975_uniform pct_99_uniform];
            
            
                        
            y_pgbs = sort(y_pgbs);
            pct_005_pgbs = y_pgbs(round(S_max/200));
            pct_01_pgbs = y_pgbs(round(S_max/100));
            pct_025_pgbs = y_pgbs(round(S_max/40));
            pct_05_pgbs = y_pgbs(round(S_max/20));
            pct_10_pgbs = y_pgbs(round(S_max/10));
            pct_50_pgbs = y_pgbs(round(S_max/2));
            pct_90_pgbs = y_pgbs(round(S_max*9/10));
            pct_95_pgbs = y_pgbs(round(S_max*19/20));
            pct_975_pgbs = y_pgbs(round(S_max*39/40));
            pct_99_pgbs = y_pgbs(round(S_max*99/100));
            pct_995_pgbs = y_pgbs(round(S_max*199/200));
            pct_pgbs_rep(b,:) = [pct_01_pgbs pct_025_pgbs pct_05_pgbs pct_10_pgbs pct_50_pgbs pct_90_pgbs pct_95_pgbs pct_975_pgbs pct_99_pgbs];
            
            
            t_pgbs = sort(t_pgbs);
            pct_005_pgbspiv = t_pgbs(round(S_max/200));
            pct_01_pgbspiv = t_pgbs(round(S_max/100));
            pct_025_pgbspiv = t_pgbs(round(S_max/40));
            pct_05_pgbspiv = t_pgbs(round(S_max/20));
            pct_10_pgbspiv = t_pgbs(round(S_max/10));
            pct_50_pgbspiv = t_pgbs(round(S_max/2));
            pct_90_pgbspiv = t_pgbs(round(S_max*9/10));
            pct_95_pgbspiv = t_pgbs(round(S_max*19/20));
            pct_975_pgbspiv = t_pgbs(round(S_max*39/40));
            pct_99_pgbspiv = t_pgbs(round(S_max*99/100));
            pct_995_pgbspiv = t_pgbs(round(S_max*199/200));
            pct_pgbspiv_rep(b,:) = [pct_01_pgbspiv pct_025_pgbspiv pct_05_pgbspiv pct_10_pgbspiv pct_50_pgbspiv pct_90_pgbspiv pct_95_pgbspiv pct_975_pgbspiv pct_99_pgbspiv];
            
            
            
            


            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Evaluate coverage and confidence interval length %
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            lw_ix = ceil(S_max/200);
            up_ix = ceil(S_max*199/200)+1;
            
            var_an(b,1) = sigma2_hat/N/T;
            var_bs(b,1) = var(y_bs)*sigma2_hat/N/T;
                                 
                   
            % two-sided rejection rates
            
            t_bs_sym = sort(abs(t_bs));
            crit_sym_bs = t_bs_sym(99*S_max/100);
            t_nosel_sym = sort(abs(t_nosel));
            crit_sym_nosel = t_nosel_sym(99*S_max/100);
            
            
            rej_gauss = abs(t_rep(b,1))>=2.5758;
            rej_bs = (t_rep(b,1)<=-pct_995_bs)+(t_rep(b,1)>=-pct_005_bs);
            rej_bspiv = (t_rep(b,1)<=-pct_995_bspiv)+(t_rep(b,1)>=-pct_005_bspiv);
            rej_sym_bs = abs(t_rep(b,1))>=crit_sym_bs;
            rej_nosel = (t_rep_nosel(b,1)<=-pct_995_nosel)+(t_rep_nosel(b,1)>=-pct_005_nosel);
            rej_noselpiv = (t_rep_nosel(b,1)<=-pct_995_noselpiv)+(t_rep_nosel(b,1)>=-pct_005_noselpiv);
            rej_sym_nosel = abs(t_rep_nosel(b,1))>=crit_sym_nosel;
            rej_uniform = (t_rep(b,1)<=-pct_995_uniform)+(t_rep(b,1)>=-pct_005_uniform);
            rej_pgbs = (t_rep_nosel(b,1)<=-pct_995_pgbs)+(t_rep_nosel(b,1)>=-pct_005_pgbs);            
            rej_pgbspiv = (t_rep_nosel(b,1)<=-pct_995_pgbspiv)+(t_rep_nosel(b,1)>=-pct_005_pgbspiv);
            rej_subs = (t_rep(b,1)<=-pct_995_subs)+(t_rep(b,1)>=-pct_005_subs);
            
            
            
            rej_all(b,:) = [rej_gauss rej_bs rej_bspiv rej_sym_bs rej_nosel rej_noselpiv rej_sym_nosel rej_uniform rej_pgbs rej_pgbspiv rej_subs];
            
            
            % one-sided rejection rates
            
            one_side_gauss_l = t_rep(b,1)<=-2.326;
            one_side_bs_l = t_rep(b,1)<=pct_01_bs;
            one_side_bspiv_l = t_rep(b,1)<=pct_01_bspiv;
            one_side_nosel_l = t_rep_nosel(b,1)<=pct_01_nosel;
            one_side_noselpiv_l = t_rep_nosel(b,1)<=pct_01_noselpiv;
            one_side_uniform_l = t_rep(b,1)<=pct_01_uniform;
            one_side_pgbspiv_l = t_rep_nosel(b,1)<=pct_01_pgbspiv;
            one_side_subs_l = t_rep(b,1)<=pct_01_subs;
            
            one_side_gauss_u = t_rep(b,1)>=2.326;
            one_side_bs_u = t_rep(b,1)>=pct_99_bs;
            one_side_bspiv_u = t_rep(b,1)>=pct_99_bspiv;
            one_side_nosel_u = t_rep_nosel(b,1)>=pct_99_nosel;
            one_side_noselpiv_u = t_rep_nosel(b,1)>=pct_99_noselpiv; 
            one_side_uniform_u = t_rep(b,1)>=pct_99_uniform;
            one_side_pgbspiv_u = t_rep_nosel(b,1)>=pct_99_pgbspiv;
            one_side_subs_u = t_rep(b,1)>=pct_99_subs; 
           
            
            one_side_all(b,:) = [one_side_gauss_l one_side_bspiv_l one_side_noselpiv_l one_side_uniform_l one_side_pgbspiv_l one_side_subs_l one_side_gauss_u one_side_bspiv_u one_side_noselpiv_u one_side_uniform_u one_side_pgbspiv_u one_side_subs_u];

      
            
            pct_gauss_rep(b,:) = norminv([0.01 0.025 0.05 0.1 0.5 0.9 0.95 0.975 0.99],0,1);%*sqrt(sigma2_hat);
                     
                nom_prob = (1:50)/50-0.01;
            
                pctile_gauss = norminv(nom_prob,0,1);
                rej_gauss_gph(b,:) = repmat(t_rep(b,1),1,50)<pctile_gauss;

            
                t_subs = sort(t_subs);
                t_mat = reshape(t_subs,S_max/50,50);
                pctile_subs = 0.5*(t_mat(floor(S_max/100),:)+t_mat(ceil(S_max/100+1),:));
                rej_subs_gph(b,:) = repmat(t_rep(b,1),1,50)<pctile_subs;
                
                
                
                y_bs = sort(y_bs);
                y_mat = reshape(y_bs,S_max/50,50);
                pctile_bs = y_mat(ceil(S_max/100),:);
                pctile_bs = 0.5*(y_mat(floor(S_max/100),:)+y_mat(ceil(S_max/100+1),:));
                rej_bs_gph(b,:) = repmat(t_rep(b,1),1,50)<pctile_bs;
                
            
                t_bs = sort(t_bs);
                t_mat = reshape(t_bs,S_max/50,50);
                pctile_bspiv = t_mat(ceil(S_max/100),:);
                pctile_bspiv = 0.5*(t_mat(floor(S_max/100),:)+t_mat(ceil(S_max/100+1),:));
                rej_bspiv_gph(b,:) = repmat(t_rep(b,1),1,50)<pctile_bspiv;
  
        end

        pct_gauss_rep = pct_gauss_rep;
       

        t_rep = sort(y_rep./sqrt(var_an));
        pct_01_true = t_rep(round(B_max/100));
        pct_025_true = t_rep(round(B_max/40));
        pct_05_true = t_rep(round(B_max/20));
        pct_10_true = t_rep(round(B_max/10));
        pct_50_true = t_rep(round(B_max/2));
        pct_90_true = t_rep(round(B_max*9/10));
        pct_95_true = t_rep(round(B_max*19/20));
        pct_975_true = t_rep(round(B_max*39/40));
        pct_99_true = t_rep(round(B_max*99/100));
        pct_true = [pct_01_true pct_025_true pct_05_true pct_10_true pct_50_true pct_90_true pct_95_true pct_975_true pct_99_true];
        
        pct_bs = mean(pct_bs_rep);
        pct_bspiv = mean(pct_bspiv_rep);
        
        pct_gauss = mean(pct_gauss_rep);
        pct_subs = mean(pct_subs_rep);
        
        

        
 
        rej_rate = mean(rej_all);
        os_rej = mean(one_side_all);
        
         
        
        
        tru_var = var(y_rep);
        std_err = [mean(var_an/tru_var) mean(var_bs/tru_var)]; 
   
        
        pct_all(1,:) = pct_true;
        pct_all(2,:) = pct_subs;
        pct_all(3,:) = pct_gauss;
        pct_all(4,:) = pct_bs;
        pct_all(5,:) = pct_bspiv;
           
        pct_err_all(1,:) = mean(pct_gauss_rep-repmat(pct_true,B_max,1));
        pct_err_all(2,:) = mean(pct_subs_rep-repmat(pct_true,B_max,1));
        pct_err_all(3,:) = mean(pct_bs_rep-repmat(pct_true,B_max,1));
        pct_err_all(4,:) = mean(pct_bspiv_rep-repmat(pct_true,B_max,1));
        
        mse_all(1,:) = mean((pct_gauss_rep-repmat(pct_true,B_max,1)).^2);
        mse_all(2,:) = mean((pct_subs_rep-repmat(pct_true,B_max,1)).^2);
        mse_all(3,:) = mean((pct_bs_rep-repmat(pct_true,B_max,1)).^2);
        mse_all(4,:) = mean((pct_bspiv_rep-repmat(pct_true,B_max,1)).^2);
        
        
        
        end

