function [y_bs,t_bs,sig2_star,sig2e_star] = twcl_bootstrap(y,sigma2_hat,S_max,lambda1,lambda2,swtch1,swtch2,dyadic)
        
    [N,T] = size(y);
            
    alpha_hat = mean(y,2) - mean(mean(y));
    gamma_hat = mean(y,1) - mean(mean(y));            
    eps_hat = y - repmat(alpha_hat,1,T) - repmat(gamma_hat,N,1) - mean(mean(y));        
            
    y_bs = zeros(S_max,1);
    t_bs = zeros(S_max,1);
    sig2_star = zeros(S_max,1);
    sig2e_star = zeros(S_max,1);
            
       
    for s = 1:S_max    
                  
        i_vec = ceil(N*rand(N,1));
        alpha_star = (alpha_hat(i_vec)-mean(alpha_hat));  
        t_vec = ceil(T*rand(T,1));
        gamma_star = (gamma_hat(t_vec)-mean(gamma_hat));
        
        p = (sqrt(5)+1)/(2*sqrt(5));
        rdsg1 = rand(N,1)<p;
        omega_e1 = (1-rdsg1)*(sqrt(5)+1)/2 - rdsg1*(sqrt(5)-1)/2;
        rdsg2 = rand(1,T)<p;
        omega_e2 = (1-rdsg2)*(sqrt(5)+1)/2 - rdsg2*(sqrt(5)-1)/2;
        
        
        omega_e1 = gamrnd(4,0.5,N,1)-2;
        omega_e2 = gamrnd(4,0.5,1,T)-2;
        
        if dyadic == 1
            gamma_star = alpha_star';
            omega_e2 = omega_e1';
            T = N;
        end
        
        
        
        
        
        omega_e = omega_e1*omega_e2;
        epsilon_star = omega_e.*(eps_hat-mean(mean(eps_hat))); 
        
        y_star = sqrt(lambda1)*repmat(alpha_star,1,T) + sqrt(lambda2)*repmat(gamma_star,N,1)+epsilon_star;
              
        if dyadic==1
            y_star = y_star - mean(alpha_star.^2);
        end
            
        alph_hat_star = mean(y_star,2) - mean(mean(y_star));
        gamm_hat_star = mean(y_star,1) - mean(mean(y_star));
        eps_hat_star = y_star-repmat(alph_hat_star,1,T)-repmat(gamm_hat_star,N,1) - mean(mean(y_star));     
        
        sigma2_e_star = var(reshape(eps_hat_star,N*T,1));
        sigma2_a_star = max(var(alph_hat_star) - sigma2_e_star/T,0);
        sigma2_g_star = max(var(gamm_hat_star') - sigma2_e_star/N,0);
        
        sigma2_star = swtch1*T*sigma2_a_star + swtch2*N*sigma2_g_star + sigma2_e_star;
        
     
        
        y_bs(s,:) = mean(mean(y_star))*sqrt(N*T/sigma2_hat);
        t_bs(s,:) = mean(mean(y_star))*sqrt(N*T/sigma2_star);
        sig2_star(s,:) = sigma2_star;
        sig2e_star(s,:) = var(reshape(eps_hat_star,N*T,1));
                
            
    end
            

            
end